#!/bin/bash
PRODUCTNAME="supervision"
TMPDIR="/tmp/supervision"
INSTALLDIR="/usr/share/ombutel/www"
IPCDIR="/etc/ipconnect"
OLDVERSION=-1
NEWVERSION=-1
MAJORVERSION=3

mkdir -p "$TMPDIR"
mkdir -p "$IPCDIR"

if [ -e "$IPCDIR/$PRODUCTNAME.ver" ]
then
    OLDVERSION=$(cat "$IPCDIR/$PRODUCTNAME.ver" |cut -d"." -f2)
fi
NEWVERSION=$(head -n 1 "$INSTALLDIR/$PRODUCTNAME/version.txt" |cut -d"." -f2)
echo "-- Updating from $MAJORVERSION.$OLDVERSION to $MAJORVERSION.$NEWVERSION"


chmod +x "$INSTALLDIR/$PRODUCTNAME/InstallScripts/after_remove.sh"
chmod +x "$INSTALLDIR/$PRODUCTNAME/InstallScripts/after_update.sh"
chmod +x "$INSTALLDIR/$PRODUCTNAME/InstallScripts/before_remove.sh"

find "$INSTALLDIR/$PRODUCTNAME/api/scripts" -name '*.sh' -exec dos2unix {} 2> /dev/null \;

#On va faire une boucle à partir de "ancienne version + 1" jusqu'a la derniere version incluse
i=$(($OLDVERSION+1))
if [ $OLDVERSION -eq $NEWVERSION ]
then
	i=$OLDVERSION;
	echo "-- Updating same version but different revision, reexecuting patch of $i"
fi

while [ $i -le $NEWVERSION ]
do
    if [ -d "$INSTALLDIR/$PRODUCTNAME/InstallScripts/$MAJORVERSION.$i" ]
    then
        echo "-- Executing patch $MAJORVERSION.$i"
        find "$INSTALLDIR/$PRODUCTNAME/InstallScripts/$MAJORVERSION.$i" -name '*' -exec dos2unix {} 2> /dev/null \;
        if [ -f "$INSTALLDIR/$PRODUCTNAME/InstallScripts/$MAJORVERSION.$i/update.sh" ]
        then
            bash "$INSTALLDIR/$PRODUCTNAME/InstallScripts/$MAJORVERSION.$i/update.sh"
        fi
    fi
    i=$(($i+1))
done

#creation du lien pour le chat
if [ ! -d "$INSTALLDIR/$PRODUCTNAME/attachements" ]
then
  mkdir -p /usr/share/amiserv5/attachements
  ln -s "/usr/share/amiserv5/attachements/" "$INSTALLDIR/$PRODUCTNAME/attachements"
fi

echo "$MAJORVERSION.$NEWVERSION" > "$IPCDIR/$PRODUCTNAME.ver"
echo "-- Update finished"


rm -rf "$TMPDIR"
exit